;;;Bosse-engineering                                                                                       
;;;Dipl.-Ing. Jrn Bosse                                                                                   
;;;Am Klei 5	                                                                                           
;;;384458 Velpke                                                                                           
;;;Tel. 05361 / 989 677                                                                                    
;;;mobil. 0176 / 232 828 51                                                                                
;;;bosse@bosse-engineering.com                                                                             
;;;                                                                                                        
;;;--------------------------------------------------------------------------------------------------------
;;;WorkShop "LISP-Programmierung" 18.11.09								   
;;;--------------------------------------------------------------------------------------------------------

;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Hauptfunktion AttManipulate1 => 1. Beispiel: Att manipulieren		   
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

(defun c:AttManipulate1 ( / AWS N ATTWERT)
  (if (setq aws (ssget (list '(0 . "INSERT")'(8 . "RWA-SCA-SYM"))))
    (progn
      (setq n 0)
      (repeat (sslength aws)
        (setq att_liste (cadr(assoc "SCANR"(JBf_WorkShop:Block:Attliste:get (ssname aws n))))
              attwert (cdr(assoc 1 att_liste)))
        ;;;Attteil "R" gegen "RWA" tauschen
        (setq attwert (if(not(vl-string-search "RWA" attwert))
                         (vl-string-subst "RWA" "R" attwert)
                         attwert))
        ;;;Attteil ".#." per Adition um einen zu erhhen
        (if(and
             (setq attwert_liste (JBf_WorkShop:String->List attwert "."))
             (=(length attwert_liste)3))
        (setq attwert_liste (subst(itoa(+(atoi (nth 2 attwert_liste))100))(nth 2 attwert_liste)attwert_liste)
              attwert (JBf_WorkShop:List->String 'T attwert_liste ".")))
        (entmod(subst (cons 1 attwert)(assoc 1 att_liste)att_liste))
        (entupd (ssname aws n));;;Block updaten, damit Attribute aktualisiert werden
        (setq n (+ n 1))))
      (alert "\nEs wurden keine gltigen Attribute ausgewhlt."))
  (princ))



;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Hauptfunktion AttManipulate1 => 2. Beispiel: Att manipulieren		   
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

(defun c:AttManipulate2 ( / AWS N ATTWERT)
  (if (setq aws (ssget (list '(0 . "INSERT")'(8 . "RWA-SCA-SYM"))))
    (progn
      (setq n 0)
      (repeat (sslength aws)
        (mapcar '(lambda(A)
                   (setq att_liste (cadr(assoc A(JBf_WorkShop:Block:Attliste:get (ssname aws n))))
                         attwert (cdr(assoc 1 att_liste)))
                   ;;;Attteil "  " gegen "=" tauschen
                   (setq attwert (if(not(vl-string-search "=" attwert))
                                   (vl-string-subst "=" "  " attwert)
                                   attwert))
                   ;;;Deckelhhen +1.00, Tiefen +1.00
                   (if (member (substr attwert 1 1)'("D" "T"))
                     (setq attwert
                            (strcat
                              (substr attwert 1 (+(vl-string-search "=" attwert)1))
                              (rtos(+(atof(substr attwert (+(vl-string-search "=" attwert)2)))1.0)2 2))))
                   (entmod(subst (cons 1 attwert)(assoc 1 att_liste)att_liste))
                   )'("DECKELHOEHE" "SOHLHOEHE-TIEFE1" "SOHLHOEHE-TIEFE2"))
        (entupd (ssname aws n));;;Block updaten, damit Attribute aktualisiert werden
        (setq n (+ n 1))))
    (alert "\nEs wurden keine gltigen Attribute ausgewhlt."))
  (princ))
                                  

;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Funktion JBf_WorkShop:String->List => String in Liste, Trennung per Zeichen     
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;;;-> string: Stringelement
;;;-> trennzeichen: Trennzeichen als String
;;;<- Liste, mit einzelnen Stringelementen

(defun JBf_WorkShop:String->List (string trennzeichen / LISTE)
  (if (vl-string-search trennzeichen string)
    (progn
      (while (vl-string-search trennzeichen string)
        (setq liste (cons (substr string 1 (vl-string-search trennzeichen string))liste)
              string (substr string(+(vl-string-search trennzeichen string)(+ (strlen trennzeichen)1)))))
      (setq liste (cons string liste))))
    (reverse liste))

;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Funktion JBf_string_list_trenzeichen->string => Liste zu String mit Trennzeichen
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;;;-> liste: Liste, deren Elemente in String zusammengefasst werden soll
;;;-> trennzeichen: Trennzeichen fr einzelen Listenelemente
;;;-> flag: wenn 'T, dann letztes Trennzeichen entfernen
;;;<- String, zusammengesetzt aus Listenelementen
  
(defun JBf_WorkShop:List->String(flag liste trennzeichen / string)
  (setq string "")
  (mapcar '(lambda(A)
             (setq string (strcat string A trennzeichen)))liste)
  (if flag
    (vl-string-right-trim trennzeichen string)
    string))

;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Funktion JBf_WorkShop:Block:Attliste:get =>Attributsliste aus Blockobjekt       
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;;;-> elem: Element vom Typ Block
;;;<- list_att: Gruppencodeliste Attribute aus Block

(defun JBf_WorkShop:Block:Attliste:get (elem / list_att)
  (if (and (entnext elem)(=(cdr(assoc 0(entget (entnext elem))))"ATTRIB"))
    (while (and(setq elem (entnext elem))
	       (/= "SEQEND" (cdr(assoc 0(entget elem)))))
      (if (=(cdr(assoc 0(entget elem)))"ATTRIB")
	(setq list_att (cons (list (cdr(assoc 2 (entget elem)))(entget elem))list_att)))))
  (reverse list_att))

  
